/*
 *  untitled.cpp
 *  
 *
 *  Created by Feng Zhou on 6/29/11.
 *  Copyright 2011 University of Kentucky. All rights reserved.
 *
 */

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include "Matrix.h"
#include <Eigen>
#include "mtrand.h"
#include "MLE.h"


using namespace std;
using namespace Eigen;

double prob_uni(int j, Vector2d mu){
	double p;
	p = exp(mu[0] + mu[1]*(j+1))/(1 + exp(mu[0] + mu[1]*(j+1)));
	return p;
}

double prob_bi(int j, int k, Vector3d mu){
	double p;
	p = exp(mu[0] + mu[1]*(j+1) + mu[2]*(k+1))/(1 + exp(mu[0] + mu[1]*(j+1) + mu[2]*(k+1)));
	return p;
}

void no3way_Indept_IPF(int I, int J, int K, int ***Xnull, double ****p){
	int total = 0, cont = 1;
	double diff = 0, diff_abs = 0, diff_sum = 0;
	int Isum[J][K], Jsum[I][K], Ksum[I][J];
	double tmp[I][J][K], Xold[I][J][K];
	double oldIsum[J][K], oldJsum[I][K], oldKsum[I][J],
	tmpIsum[J][K], tmpJsum[I][K], tmpKsum[I][J];
	
	for(int i = 0; i < I; i++){
		for(int j = 0; j < J; j++){
			for (int k = 0; k < K; k++) {
				total += Xnull[i][j][k];
			}
		}
	}
	
	
	for (int j = 0; j < J; j++) {
		for (int k = 0; k < K; k++) {
			Isum[j][k] = 0;
			for (int i = 0; i < I; i++) {
				Isum[j][k] += Xnull[i][j][k];
				
			}
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int k = 0; k < K; k++) {
			Jsum[i][k] = 0;
			for (int j = 0; j < J; j++) {
				Jsum[i][k] += Xnull[i][j][k];
			}
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			Ksum[i][j] = 0;
			for (int k = 0; k < K; k++) {
				Ksum[i][j] += Xnull[i][j][k];
			}
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				Xold[i][j][k] = 0.008926;
			}
		}
	}
	
	while (cont = 1) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				oldIsum[j][k] = 0.0;
				for (int i = 0; i < I; i++) {
					oldIsum[j][k] += Xold[i][j][k];
					
				}
			}
		}
		
		
		for(int j = 0; j < J; j++){
			for(int k = 0; k < K; k++){
				if(oldIsum[j][k] > 0){
					for (int i = 0; i < I; i++){ 
						tmp[i][j][k] = Xold[i][j][k] * ((double)Isum[j][k]) / oldIsum[j][k]/total;	
					}		
				}
			}
		}
		
		for (int i = 0; i < I; i++){
			for (int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					diff += (tmp[i][j][k] - Xold[i][j][k]);
					if (diff < 0) {diff_abs = -diff;}
					else {diff_abs = diff;}
					diff_sum +=diff_abs;	
					
				}
			}
		}
		
		
		if (diff_sum < 0.000001) {
			for (int j = 0; j < J; j++) {
				for (int k = 0; k < K; k++) {
					tmpIsum[j][k] = 0.0;
					for (int i = 0; i < I; i++) {
						tmpIsum[j][k] += tmp[i][j][k];
					}
				}
			}
			
			
			for(int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					for(int i = 0; i < I; i++){
						(*p)[i][j][k] = tmp[i][j][k]/tmpIsum[j][k];
					}
				}
			}
			
			
			
		    
			cont = 0;
			break;	
			
		}
		
		
		
		else {
			for(int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					for(int i = 0; i < I; i++){
						Xold[i][j][k] = tmp[i][j][k];
					}
				}
			}
		}
		
		
		
		for (int i = 0; i < I; i++) {
			for (int k = 0; k < K; k++) {
				oldJsum[i][k] = 0.0;
				for (int j = 0; j < J; j++) {
					oldJsum[i][k] += Xold[i][j][k];
				}
			}
		}
		
		for (int i = 0; i < I; i++) {
			for (int k = 0; k < K; k++) {
				if(oldJsum[i][k] > 0){
					for (int j = 0; j < J; j++) {
						tmp[i][j][k] = Xold[i][j][k] * ((double)Jsum[i][k]) / oldJsum[i][k]/total;	
					}	
				}
			}
		}
		
		diff = 0;
		diff_abs = 0;
		diff_sum = 0;
		
		for(int i = 0; i < I; i++){
			for(int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					diff += (tmp[i][j][k] - Xold[i][j][k]);
					if (diff < 0) {diff_abs = -diff;}
					else {diff_abs = diff;}
					diff_sum +=diff_abs;	
					
				}
			}
		}
		
		
		if (diff_sum < 0.000001) {
			for (int j = 0; j < J; j++) {
				for (int k = 0; k < K; k++) {
					tmpIsum[j][k] = 0.0;
					for (int i = 0; i < I; i++) {
						tmpIsum[j][k] += tmp[i][j][k];
					}
				}
			}
			
			for(int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					for(int i = 0; i < I; i++){
						(*p)[i][j][k] = tmp[i][j][k]/tmpIsum[j][k];
					}
				}
			}
			cont = 0;
			
			break;
			
		}
		
		
		else {
			for(int i = 0; i < I; i++){
				for (int k = 0; k < K; k++) {
					for(int j = 0; j < J; j++){
						Xold[i][j][k] = tmp[i][j][k];
					}
				}
			}
		}
		
		
		
		
		for (int i = 0; i < I; i++) {
			for (int j = 0; j < J; j++) {
				oldKsum[i][j] = 0.0;
				for (int k = 0; k < K; k++) {
					oldKsum[i][j] += Xold[i][j][k];
				}
			}
		}
		
		for (int i = 0; i < I; i++) {
			for (int j = 0; j < J; j++) {
				if(oldKsum[i][j] > 0){
					for (int k = 0; k < K; k++) {
						tmp[i][j][k] = Xold[i][j][k] * ((double)Ksum[i][j]) / oldKsum[i][j]/total;	
					}
				}
			}
		}
		
		diff = 0;
		diff_abs = 0;
		diff_sum = 0;
		
		for(int i = 0; i < I; i++){
			for(int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					diff += (tmp[i][j][k] - Xold[i][j][k]);
					if (diff < 0) {diff_abs = -diff;}
					else {diff_abs = diff;}
					diff_sum +=diff_abs;	
					
				}
			}
		}
		
		if (diff_sum < 0.000001) {
			for (int j = 0; j < J; j++) {
				for (int k = 0; k < K; k++) {
					tmpIsum[j][k] = 0.0;
					for (int i = 0; i < I; i++) {
						tmpIsum[j][k] += tmp[i][j][k];
					}
				}
			}
			
			for(int j = 0; j < J; j++){
				for (int k = 0; k < K; k++) {
					for(int i = 0; i < I; i++){
						(*p)[i][j][k] = tmp[i][j][k]/tmpIsum[j][k];
					}
				}
			}
			cont = 0;
			
			break;
		}
		
		else {
			for(int i = 0; i < I; i++){
				for (int j = 0; j < J; j++) {
					for(int k = 0; k < K; k++){
						Xold[i][j][k] = tmp[i][j][k];
					}
				}
			}
		}	
		
		
		
	}
	
//		for (int i = 0; i < I; i++) {
//			for (int j = 0; j < J; j++) {
//				for (int k = 0; k < K; k++) {
//					cout << (*p)[i][j][k] << " "; 
//				}
//				cout << endl;
//			}
//			cout << endl;
//		}
//		cout << endl; 
	
}



Vector2d para_1st_uni(int J, int *XJ, Vector2d mu, Matrix2 *ss){
	double u[2] = {0};
	Vector2d uPtr;
	for (int j = 0; j < J; j++) {
		u[0] = u[0] - XJ[j]*prob_uni(j, mu); 
		u[1] = u[1] - (j+1)*XJ[j]*prob_uni(j, mu);
		
	}
	u[0] = u[0] + (*ss).rowVectors[0].elements[0];
	u[1] = u[1] + (*ss).rowVectors[0].elements[1];
	
	uPtr << u[0], u[1];	
	return uPtr;
}

Vector3d para_1st_bi(int J, int K, int **XJK, Vector3d mu, Matrix2 *ss){
	double u[3] = {0};
	Vector3d uPtr;
	for (int j = 0; j < J; j++) {
		for (int k = 0; k < K; k++) {
			u[0] = u[0] - XJK[j][k] * prob_bi(j, k, mu); 
			u[1] = u[1] - (j+1)*XJK[j][k] * prob_bi(j, k, mu);
			u[2] = u[2] - (k+1)*XJK[j][k] * prob_bi(j, k, mu);
		}
	}
	u[0] = u[0] + (*ss).rowVectors[0].elements[0];
	u[1] = u[1] + (*ss).rowVectors[0].elements[1];
	u[2] = u[2] + (*ss).rowVectors[0].elements[2];
	
	uPtr << u[0], u[1], u[2];	
	return uPtr;
}

Matrix2 *hesse_uni(int J, int *XJ, Vector2d mu){
	Matrix2 *h = new Matrix2(2,2);
	double p;
	for (int j = 0; j < J; j++) {
		p = prob_uni(j, mu);
		(*h).rowVectors[0].elements[0] = (*h).rowVectors[0].elements[0] - XJ[j]*p*(1-p);
		(*h).rowVectors[0].elements[1] = (*h).rowVectors[0].elements[1] - XJ[j]*p*(1-p)*(j+1);
		(*h).rowVectors[1].elements[0] = (*h).rowVectors[1].elements[0] - XJ[j]*p*(1-p)*(j+1);
		(*h).rowVectors[1].elements[1] = (*h).rowVectors[1].elements[1] - XJ[j]*p*(1-p)*(j+1)*(j+1);
	}
	
	return h;
	
}

Matrix2 *hesse_bi(int J, int K, int **XJK, Vector3d mu){
	Matrix2 *h = new Matrix2(3,3);
	double p;
	for (int j = 0; j < J; j++) {
		for (int k = 0; k < K; k++) {
			p = prob_bi(j, k, mu);
			(*h).rowVectors[0].elements[0] = (*h).rowVectors[0].elements[0] - XJK[j][k]*p*(1-p);
			(*h).rowVectors[0].elements[1] = (*h).rowVectors[0].elements[1] - XJK[j][k]*p*(1-p)*(j+1);
			(*h).rowVectors[0].elements[2] = (*h).rowVectors[0].elements[2] - XJK[j][k]*p*(1-p)*(k+1);
			(*h).rowVectors[1].elements[1] = (*h).rowVectors[1].elements[1] - XJK[j][k]*p*(1-p)*(j+1)*(j+1);
			(*h).rowVectors[1].elements[2] = (*h).rowVectors[1].elements[2] - XJK[j][k]*p*(1-p)*(j+1)*(k+1);
			(*h).rowVectors[2].elements[2] = (*h).rowVectors[2].elements[2] - XJK[j][k]*p*(1-p)*(k+1)*(k+1);
		}
	}
	(*h).rowVectors[1].elements[0] = (*h).rowVectors[0].elements[1];
	(*h).rowVectors[2].elements[0] = (*h).rowVectors[0].elements[2];
	(*h).rowVectors[2].elements[1] = (*h).rowVectors[1].elements[2];
	return h;
	
}

Vector2d newton_uni(int J, int *XJ, Matrix2 *ss){
	Matrix2 *h;
	Matrix2d hesse, hinv;
	Vector2d u, mu, mu_new, diff, diff_abs;
	mu << 0, 0;
	int condition = 1, cont = 0;
	for (int i = 0; condition = 1; i++) {
		h = hesse_uni(J, XJ, mu);	
		hesse << (*h).rowVectors[0].elements[0], (*h).rowVectors[0].elements[1],
		(*h).rowVectors[1].elements[0],(*h).rowVectors[1].elements[1];	
		hinv = hesse.inverse();		
		u = para_1st_uni(J, XJ, mu, ss);
		mu_new = mu - hinv * u;
	    diff = mu_new-mu;
		for (int i = 0; i < 2; i++) {
			if (diff[i] < 0) diff_abs[i] = -diff[i];
			else diff_abs[i] = diff[i];
			
		}
		
		if (diff_abs.sum()< 0.0000001){
			condition = 0;
			mu = mu_new;
			break;
		}
		else {
			mu = mu_new;
		}
		cont = cont + 1;
		if (cont > 100) {
			mu << -10000, -10000;
			break;
		}
		
	}	
	return mu;
	
}

Vector3d newton_bi(int J, int K, int **XJK, Matrix2 *ss){
	Matrix2 *h;
	Matrix3d hesse, hinv;
	Vector3d u, mu, mu_new, diff, diff_abs;
	mu << 0, 0, 0;
	int condition = 1, cont = 0;
	for (int i = 0; condition = 1; i++) {
		h = hesse_bi(J, K, XJK, mu);	
		hesse << (*h).rowVectors[0].elements[0], (*h).rowVectors[0].elements[1], (*h).rowVectors[0].elements[2],
		(*h).rowVectors[1].elements[0], (*h).rowVectors[1].elements[1], (*h).rowVectors[1].elements[2],
		(*h).rowVectors[2].elements[0], (*h).rowVectors[2].elements[1], (*h).rowVectors[2].elements[2];	
		hinv = hesse.inverse();		
		u = para_1st_bi(J, K, XJK, mu, ss);
		mu_new = mu - hinv * u;
	    diff = mu_new-mu;
		for (int i = 0; i < 3; i++) {
			if (diff[i] < 0) diff_abs[i] = -diff[i];
			else diff_abs[i] = diff[i];
			
		}
		
		if (diff_abs.sum()< 0.0000001){
			condition = 0;
			mu = mu_new;
			break;
		}
		else {
			mu = mu_new;
		}
		cont = cont + 1;
		if (cont > 100) {
			mu << -10000, -10000, -10000;
			break;
		}
		
	}	
	return mu;
	
}


