/*
 *  length.cpp
 *  
 *
 *  Created by Feng Zhou on 6/29/11.
 *  Copyright 2011 University of Kentucky. All rights reserved.
 *
 */

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include "Matrix.h"
#include <Eigen>
#include "mtrand.h"

#include "length.h"

using namespace std;
using namespace Eigen;

int maxl_uni(int I, int J, Matrix2 *cell, int **XIJ){
	int l = 1, cont =1, temp, **tmp;
	
	tmp = new int *[I];
	for (int i = 0; i < I; i++) {
		tmp[i] = new int[J]; 
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			tmp[i][j] = XIJ[i][j];
		}
	}
	
	while (cont = 1) {
		int flag1 = 0, flag2 = 0;
		
		for (int i = 0; i < 2; i++) {
			temp = (*cell).rowVectors[0].elements[i];
			tmp[0][temp] = tmp[0][temp] - 1;
			if (tmp[0][temp] == 0) {flag1++;}
			if (tmp[0][temp] < 0) {flag2++;}
		}
		
		for (int i = 2; i < 4; i++) {
			temp = (*cell).rowVectors[0].elements[i];
			tmp[1][temp] = tmp[1][temp] - 1;
			if (tmp[0][temp] == 0) {flag1++;}
			if (tmp[0][temp] < 0) {flag2++;}
		}
		
		if (flag2 > 0) {
			l = l - 1;
			break;
		}
		
		if (flag1 > 0) {
			break;
		}
		
		if (flag1 == 0 & flag2 == 0) {l = l + 1;}
		
	}
	
	for(int i = 0; i < I; i++) delete tmp[i];
	delete tmp;

	return l;
}

int maxl_bi(int I, int J, int K, Matrix2 *cell, int ***Xnull){
	int l = 1, cont =1, tempj, tempk;
	int ***tmp;
	
    tmp = new int **[I];
	
	for (int i = 0; i < I; i++) {
		(tmp)[i] = new int *[J];
		for (int j = 0; j < J; j++) {
			(tmp)[i][j] = new int [K];
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				tmp[i][j][k] = (Xnull)[i][j][k];
			}
		}
	}
	while (cont = 1) {
		int flag1 = 0, flag2 = 0;
		
		for (int i = 1; i < 3; i++) {
			tempj = (*cell).rowVectors[i].elements[0];
			tempk = (*cell).rowVectors[i].elements[1];
			(tmp)[0][tempj][tempk] = (tmp)[0][tempj][tempk] - 1;
			if ((tmp)[0][tempj][tempk] == 0) {flag1++;}
			if ((tmp)[0][tempj][tempk] < 0) {flag2++;}
		}
		
		
		for (int i = 0; i < 4; i+=3) {
			tempj = (*cell).rowVectors[i].elements[0];
			tempk = (*cell).rowVectors[i].elements[1];
			(tmp)[1][tempj][tempk] = (tmp)[1][tempj][tempk] - 1;
			if ((tmp)[1][tempj][tempk] == 0) {flag1++;}
			if ((tmp)[1][tempj][tempk] < 0) {flag2++;}
			
			
		}
		if (flag2 > 0) {
			l = l - 1;
			break;
		}
		
		if (flag1 > 0) {
			break;
		}
		
		if (flag1 == 0 & flag2 == 0) {l = l + 1;}
		
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			delete [] tmp[i][j];
		}
		delete [] tmp[i];
	}
	delete [] tmp;
	
	return l;
	
	
	
}
