/*
 *  onetable.cpp
 *  
 *
 *  Created by Feng Zhou on 6/29/11.
 *  Copyright 2011 University of Kentucky. All rights reserved.
 *
 */
#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include "Matrix.h"
#include <Eigen>
#include "mtrand.h"
#include "move.h"
#include "length.h"
#include "onetable.h"

using namespace std;
using namespace Eigen;


//not used
int dist(int I, int J, int icell, int jcell, int K, int ***Xnull, MTRand_int32& irand){
    
	int flag = 0, cont = 1, kstar, k;	
	int ***tmp;
	
    tmp = new int **[I];
	
	for (int i = 0; i < I; i++) {
		(tmp)[i] = new int *[J];
		for (int j = 0; j < J; j++) {
			(tmp)[i][j] = new int [K];
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				tmp[i][j][k] = (Xnull)[i][j][k];
			}
		}
	}
    
	
	while(cont = 1){
		kstar = irand() % K;
		
		if (icell == 0 or icell == 1) {
			tmp[0][jcell][kstar] = tmp[0][jcell][kstar] - 1;
			tmp[1][jcell][kstar] = tmp[1][jcell][kstar] + 1;
			flag = 1;
		}
		
		else {
			tmp[0][jcell][kstar] = tmp[0][jcell][kstar] + 1;
			tmp[1][jcell][kstar] = tmp[1][jcell][kstar] - 1;
			flag = 2;
		}
		
		if (tmp[0][jcell][kstar] < 0 and flag ==1) {
			tmp[0][jcell][kstar] = tmp[0][jcell][kstar] + 1;
			tmp[1][jcell][kstar] = tmp[1][jcell][kstar] - 1;
		}
		
		else if (tmp[1][jcell][kstar] < 0 and flag ==2){
			tmp[0][jcell][kstar] = tmp[0][jcell][kstar] - 1;
			tmp[1][jcell][kstar] = tmp[1][jcell][kstar] + 1;
		}
		
		else {
			k =kstar;
			break;
		}
		
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			delete [] tmp[i][j];
		}
		delete [] tmp[i];
	}
	delete [] tmp;
    
	
	return k;
	
	
	
}

int OneTable_uni(int I, int J, int K, int ****Xnull, MTRand_int32& irand){
	Matrix2 *cell;
	cell = rmove_uni(J, irand);

	int k, t, flag = 0;
	double r1 = 0, r2 = 0, r = 0;
	
	int  **XIJ;
	XIJ = new int *[I];
	for (int i = 0; i < I; i++) {
		XIJ[i] = new int[J]; 
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			XIJ[i][j] = 0;
			for (int k = 0; k < K; k++) {
				XIJ[i][j] = XIJ[i][j] + (*Xnull)[i][j][k];
				
			}
		}
	}
	
	
	int ***tmp;
	
	tmp = new int **[I];
	
	for (int i = 0; i < I; i++) {
		(tmp)[i] = new int *[J];
		for (int j = 0; j < J; j++) {
			(tmp)[i][j] = new int [K];
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				tmp[i][j][k] = (*Xnull)[i][j][k];
			}
		}
	}
	
	int xmin;
	xmin = maxl_uni(I, J, cell, XIJ);
	
	if (xmin <= 0) {flag = 1;}
	else {
		flag = 0;
		xmin = 1;
		
		
		
		
		
		for (int i = 0; i < 4; i++) {
		//	k = dist(I , J, i, (*cell).rowVectors[0].elements[i], K, *Xnull, irand);
		    k = irand() % K; 
			if (i < 2) {
				t = (*cell).rowVectors[0].elements[i];
				(*Xnull)[0][t][k] = (*Xnull)[0][t][k] - 1;
				(*Xnull)[1][t][k] = (*Xnull)[1][t][k] + 1;
				r1 = r1 + log((*Xnull)[1][t][k]);
				r2 = r2 + log((*Xnull)[0][t][k] + 1);
			}
			else {
				t = (*cell).rowVectors[0].elements[i];
				(*Xnull)[0][t][k] = (*Xnull)[0][t][k] + 1;
				(*Xnull)[1][t][k] = (*Xnull)[1][t][k] - 1;
				r1 = r1 + log((*Xnull)[0][t][k]);
				r2 = r2 + log((*Xnull)[1][t][k] + 1);
			}		
		}

		
		
		
		for (int i = 0; i < I; i++) 
			for (int j = 0; j < J; j++) 
				for (int k = 0; k < K; k++) 
					if ((*Xnull)[i][j][k]<0) flag = 1;
		
		
		
		

		
		r = exp(r2 - r1);

		
		int random = irand() % 1000;
	
		
		if (random > (int)(1000.0 * r)) {flag = 1;}
		
		
		
		if (flag == 1) {
			for (int i = 0; i < I; i++) {
				for (int j = 0; j < J; j++) {
					for (int k = 0; k < K; k++) {
						(*Xnull)[i][j][k] = tmp[i][j][k];
					}
				}
			}
		}
		
		
		
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			delete [] tmp[i][j];
		}
		delete [] tmp[i];
	}
	delete [] tmp;

	return flag;	
}

double width(int I, int J, int K, Matrix2 *cell, int ***Xnull){
	int tempj, tempk;
	double r1 = 0, r2 = 0, r = 0;
	int ***tmp;
	
    tmp = new int **[I];
	
	for (int i = 0; i < I; i++) {
		(tmp)[i] = new int *[J];
		for (int j = 0; j < J; j++) {
			(tmp)[i][j] = new int [K];
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				tmp[i][j][k] = (Xnull)[i][j][k];
			}
		}
	}
	
	for (int i = 1; i < 3; i++) {
		tempj = (*cell).rowVectors[i].elements[0];
		tempk = (*cell).rowVectors[i].elements[1];
		tmp[0][tempj][tempk] = tmp[0][tempj][tempk] - 1;
		r2 = r2 + log(tmp[0][tempj][tempk] + 1);
		tmp[1][tempj][tempk] = tmp[1][tempj][tempk] + 1;
		r1 = r1 + log(tmp[1][tempj][tempk]);
	}
	
	
	for (int i = 0; i < 4; i+=3) {
		tempj = (*cell).rowVectors[i].elements[0];
		tempk = (*cell).rowVectors[i].elements[1];
		tmp[1][tempj][tempk] = tmp[1][tempj][tempk] - 1;
		r2 = r2 + log(tmp[1][tempj][tempk] + 1);
		tmp[0][tempj][tempk] = tmp[0][tempj][tempk] + 1;	
		r1 = r1 + log(tmp[0][tempj][tempk]);
	}
	
	r = exp(r2 - r1);
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			delete [] tmp[i][j];
		}
		delete [] tmp[i];
	}
	delete [] tmp;
	
	return r;
	
}

double fact(double x){
	double fact = 0.0;
	for(int i = 1; i <= x; i++) fact -= log(((double) i));
	return fact;
}

double probRatio(int I, int J, int K, int ***oldTable, int ***newTable){
	double p = 0.0;
	for (int i = 0; i < I; i++)
		for (int j = 0; j < J; j++)
			for (int k = 0; k < K; k++)
				p += fact(((double)newTable[i][j][k])) - fact((double)oldTable[i][j][k]); 
	return exp(p);
}

int OneTable_bi(int I, int J, int K, int ****Xnull, MTRand_int32& irand){
	Matrix2 *cell;
	cell = rmove_bi(I, J, K, irand);

	
	int ***tmp;
	int tempj, tempk, flag = 0;
	
	tmp = new int **[I];
	
	for (int i = 0; i < I; i++) {
		(tmp)[i] = new int *[J];
		for (int j = 0; j < J; j++) {
			(tmp)[i][j] = new int [K];
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				tmp[i][j][k] = (*Xnull)[i][j][k];
			}
		}
	}
	
	
	int xmin;
	xmin = maxl_bi(I, J, K, cell, *Xnull);
	

	
	if (xmin <= 0) {flag = 1;}
	
	else {
		flag = 0;
		xmin = 1;
		double r;
		r = width(I, J, K, cell, *Xnull);
		

		int random = irand() % 1000;
		if (random > (int)(1000.0 * r)){flag = 1;}
		
		else {
			
			for (int i = 1; i < 3; i++) {
				tempj = (*cell).rowVectors[i].elements[0];
				tempk = (*cell).rowVectors[i].elements[1];
				(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
				(*Xnull)[1][tempj][tempk] = (*Xnull)[1][tempj][tempk] + 1;
				
			}
			
			
			for (int i = 0; i < 4; i+=3) {
				tempj = (*cell).rowVectors[i].elements[0];
				tempk = (*cell).rowVectors[i].elements[1];
				(*Xnull)[1][tempj][tempk] = (*Xnull)[1][tempj][tempk] - 1;
				(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;	
			}
			
		}
		
	}
	
	return flag;	
	
}	


int OneTable_indept(int I, int J, int K, int ****Xnull, MTRand_int32& irand){
	Matrix2 *cell;
	cell = rmove_indept(J, K, irand);
	
	int ***tmp;
	int tempj, tempk, flag = 0;
	
	tmp = new int **[I];
	
	for (int i = 0; i < I; i++) {
		(tmp)[i] = new int *[J];
		for (int j = 0; j < J; j++) {
			(tmp)[i][j] = new int [K];
		}
	}
	
	for (int i = 0; i < I; i++) {
		for (int j = 0; j < J; j++) {
			for (int k = 0; k < K; k++) {
				tmp[i][j][k] = (*Xnull)[i][j][k];
			}
		}
	}
	
	
	flag = 0;
	

	
	if (irand() % 2 == 0) {
		tempj = (*cell).rowVectors[0].elements[0];
		tempk = (*cell).rowVectors[1].elements[0];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[1][tempj][tempk] - 1;
		tempj = (*cell).rowVectors[0].elements[1];
		tempk = (*cell).rowVectors[1].elements[1];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[1][tempj][tempk] - 1;
		tempj = (*cell).rowVectors[0].elements[0];
		tempk = (*cell).rowVectors[1].elements[1];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[1][tempj][tempk] + 1;
		tempj = (*cell).rowVectors[0].elements[1];
		tempk = (*cell).rowVectors[1].elements[0];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[1][tempj][tempk] + 1;
		
	}
	else {
		tempj = (*cell).rowVectors[0].elements[0];
		tempk = (*cell).rowVectors[1].elements[0];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;
		tempj = (*cell).rowVectors[0].elements[1];
		tempk = (*cell).rowVectors[1].elements[1];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;
		tempj = (*cell).rowVectors[0].elements[0];
		tempk = (*cell).rowVectors[1].elements[1];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
		tempj = (*cell).rowVectors[0].elements[1];
		tempk = (*cell).rowVectors[1].elements[0];
		(*Xnull)[0][tempj][tempk] = (*Xnull)[0][tempj][tempk] + 1;
		(*Xnull)[1][tempj][tempk] = (*Xnull)[0][tempj][tempk] - 1;
		
		
	}
	
	
	
	
	for (int i = 0; i < I; i++) 
		for (int j = 0 ; j < J; j++) 
			for (int k = 0; k < K; k++) 
				if ((*Xnull)[i][j][k] < 0) flag = 1;
	
//	int r = irand() % 1000;
//	if(flag != 1)
//		if(r > ((int) (1000.0 * probRatio(I, J, K, tmp, (*Xnull)))))flag = 1;
	
	
	if (flag == 1) {
		for (int i = 0; i < I; i++) 
			for (int j = 0 ; j < J; j++) 
				for (int k = 0; k < K; k++)
					(*Xnull)[i][j][k] = tmp[i][j][k];
	}
	
	
	for (int i = 0; i < I; i++) {
	    for (int j = 0; j < J; j++) {
			delete [] tmp[i][j];
		}
		delete [] tmp[i];
	}
	delete [] tmp;
	
	
	return flag;	
	
}	


