/*
 *  suffstat.cpp
 *  
 *
 *  Created by Feng Zhou on 6/29/11.
 *  Copyright 2011 University of Kentucky. All rights reserved.
 *
 */


#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include "Matrix.h"
#include <Eigen>
#include "mtrand.h"

#include "suffstat.h"

using namespace std;
using namespace Eigen;

Matrix2 *suff_stat(int J, int K, int ***Xnull){
	Matrix2 *ss = new Matrix2(1,3);
	int X2[J], X3[K];
	
	for (int j = 0; j < J; j++) {
		for (int k = 0; k < K; k++) {
			(*ss).rowVectors[0].elements[0] = (*ss).rowVectors[0].elements[0] + Xnull[0][j][k];
		}
	}
	
	
	for (int j = 0; j < J; j++) {
		X2[j] = 0;
		for (int k = 0; k < K; k++) {
			X2[j]=X2[j]+Xnull[0][j][k];
		}
		(*ss).rowVectors[0].elements[1] = (*ss).rowVectors[0].elements[1] + (j+1)*X2[j];
	}
	
	for (int k = 0; k < K; k++) {
		X3[k] = 0;
		for (int j = 0; j < J; j++) {
			X3[k]=X3[k]+Xnull[0][j][k];
		}
		(*ss).rowVectors[0].elements[2] = (*ss).rowVectors[0].elements[2] + (k+1)*X3[k];
	}
	
	return ss;	
	
}

